<template>
  <UAuthForm
    :fields="fields"
    :schema="schema"
    :providers="providers"
    title="Welcome back"
    icon="i-lucide-lock"
    @submit="onSubmit"
  >
    <template #description>
      Don't have an account? <ULink to="/signup" class="text-primary-500 font-medium">Sign up</ULink>.
    </template>

    <template #password-hint>
      <ULink to="/" class="text-primary-500 font-medium">Forgot password?</ULink>
    </template>

    <template #footer>
      By signing in, you agree to our <ULink to="/" class="text-primary-500 font-medium">Terms of Service</ULink>.
    </template>
  </UAuthForm>
</template>

<script setup lang="ts">
import * as z from 'zod'
import type { FormSubmitEvent } from '@nuxt/ui'

definePageMeta({ layout: 'auth' })

useSeoMeta({ title: 'Login' })

const toast = useToast()
const { signIn } = useAuth()

const fields = [
  {
    name: 'email',
    type: 'text' as const,
    label: 'Email',
    placeholder: 'Enter your email',
    required: true
  },
  {
    name: 'password',
    label: 'Password',
    type: 'password' as const,
    placeholder: 'Enter your password'
  },
  {
    name: 'remember',
    label: 'Remember me',
    type: 'checkbox' as const
  }
]

const providers = [
  {
    label: 'Google',
    icon: 'i-simple-icons-google',
    onClick: () => {
      toast.add({ title: 'Google', description: 'Login with Google' })
    }
  },
  {
    label: 'GitHub',
    icon: 'i-simple-icons-github',
    onClick: () => {
      toast.add({ title: 'GitHub', description: 'Login with GitHub' })
    }
  }
]

const schema = z.object({
  email: z.string().email('Invalid email'),
  password: z.string().min(8, 'Must be at least 8 characters')
})

type Schema = z.output<typeof schema>

function onSubmit(payload: FormSubmitEvent<Schema>) {
  if (!payload.data.email || !payload.data.password) {
    alert('Bitte alle Felder ausfüllen')
    return
  }
  signIn.email(
    {
      email: payload.data.email,
      password: payload.data.password
    },
    {
      onRequest: () => {
        // TODO: Show loading spinner
        console.log('Sending login request')
      },
      onResponse: () => {
        // TODO: Hide loading spinner
        console.log('Receiving login response')
      },
      onSuccess: async (ctx) => {
        console.log('Successfully logged in!', ctx)
        await navigateTo('/')
      },
      onError: (ctx) => {
        console.log(ctx.error.message)
        useToast().add({
          title: 'Fehler bei der Anmeldung',
          description: ctx.error.message,
          color: 'error'
        })
      }
    }
  )
}
</script>
